# -*- coding: utf-8 -*-
from __future__ import absolute_import, print_function

from flask import request, g
from flask import current_app as app

from . import Resource
from .. import schemas
import requests

import os, subprocess

from worker import *

from rq import Queue

SHARED_DATA_FOLDER = "/opt/data/"
EVAL_TOOL_PATH = "/opt/www/espamai/"
EVAL_TOOL = "./bin/espam"
NEURAGHE_TOOL = "/opt/www/convnet"
APP_TEMPLATE_PYTORCH = "/opt/www/convnet/tools/onnxparser/pytorchWriters/app_template/"

def send_back_status(project_id, status, log, engine):
  data={
    "status":status,
    "log": log,
    "info": {"type":"code_generation", "engine": engine }
  }


  print('Sending status to frontend')


  url='http://orchestrator_be:5000/api/projects/%s/status'%(str(project_id))


  print("Request URL %s" % url)
  print("Request data %s" % str(data))

  r = requests.post(url, json=data)

  print("Response status code %s" % r.status_code )



def codegen (**kwargs):

  onnx_path   = kwargs.get("onnx_path", None)
  app_name    = kwargs.get("app_name", None)
  project_id  = kwargs.get("project_id", None)
  engine      = kwargs.get("engine", None)
  callback_id = kwargs.get("callback_id", None)

  app_name, task = app_name.split(':')

  onnx_path = os.path.join(SHARED_DATA_FOLDER, onnx_path)

  if not os.path.isfile(onnx_path):
    print ("ERROR: file %s doesn't exist" % onnx_path)
    send_back_status(project_id, "Error", "ERROR: file %s doesn't exist" % onnx_path, engine)
    return


  #export_path = "experiments/prj_%s/code/%s" % (project_id,engine)
  #output_path = os.path.join (SHARED_DATA_FOLDER, export_path)
  #os.makedirs(output_path, exist_ok=True)

  output_path         = os.path.join (SHARED_DATA_FOLDER, "experiments/prj_%s/code/%s" % (project_id,engine))
  
  template_folder     = os.path.join (SHARED_DATA_FOLDER, "template")

  if engine == "PlainC" or engine == "NEURAghe" or engine == "Dynamic":

    #########################################
    ### NEURAghe General Purpose and HWCE ###
    #########################################
   
    output_path_src     = os.path.join (output_path,app_name, "src")
    output_path_weights = os.path.join (output_path,app_name, "weights")
    
    os.makedirs(output_path_src,     exist_ok=True)
    os.makedirs(output_path_weights, exist_ok=True)
    
    if engine == "NEURAgheHWCE":
      target="NEURAghe"
      params = "-F --nRow 2 --nCol 2"
    elif engine == "PlainC":
      target="plainC"
      params = "-F"
    else:
      target="plainC"
      params = "-F"
    
    os.chdir(NEURAGHE_TOOL)

    print ("Creating app...")
    command = "bash create_project.sh -T {} {} -q -O {} {} {}".format(target, params, output_path, app_name, onnx_path)
    print (command)
    ret=subprocess.call(command, shell=True)
    if ret ==0:
      print ("Done.")
   
      with open(os.path.join(output_path,app_name,"README"), 'w') as f:
        f.write("This application has been autogenerated by the ALOHA toolflow - www.aloha-h2020.eu\n")
        f.write("It should be embedded in the NEURAghe Framework available on the ALOHA repository \n")
        
      print ("Creating archive...")
      import shutil
      shutil.make_archive(os.path.join(output_path, app_name), 'zip', os.path.join(output_path,app_name))
      print ("Done.")
      send_back_status(project_id, "Finished", "The code is in the project folder", engine)
    else:
      send_back_status(project_id, "Error", "Something went wrong creating the app.", engine)
      
  elif engine == "PyTorch":
    from onnxparser import onnxextract
    target = "pytorch"
    print ("Creating PyTorch app...")
   
    pipeline_path = onnx_path, os.path.join("../preprocessing_pipeline.json")
   
    subprocess.call("mkdir -p %s" % (os.path.join(output_path,app_name)), shell=True)
    subprocess.call("cp -rf %s/* %s" % (APP_TEMPLATE_PYTORCH, os.path.join(output_path,app_name)), shell=True)
    subprocess.call("cp -rf %s %s" % (os.path.join(SHARED_DATA_FOLDER, "plugins"), os.path.join(output_path,app_name)), shell=True) # copy plugins
    subprocess.call("cp -rf %s %s" % (pipeline_path, os.path.join(output_path,app_name)), shell=True) # copy pipeline
    
    command = "onnxparser.py {} {} -T {} -t {} -P {}".format(onnx_path, app_name, target, task, os.path.join(output_path,app_name))
    print (command)
    
    ret=subprocess.call(command, shell=True)
    if ret ==0:
      print ("Done.")
   
      with open(os.path.join(output_path,app_name,"README"), 'w') as f:
        f.write("This application has been autogenerated by the ALOHA toolflow - www.aloha-h2020.eu\n")
        f.write("It should be embedded in the NEURAghe Framework available on the ALOHA repository \n")
        
      print ("Creating archive...")
      import shutil
      shutil.make_archive(os.path.join(output_path, app_name), 'zip', os.path.join(output_path,app_name))
      print ("Done.")
      send_back_status(project_id, "Finished", "The code is in the project folder", engine)
    else:
      send_back_status(project_id, "Error", "Something went wrong creating the app.", engine)
      
    
  elif engine == "espam": #"Dynamic"
    
    ################################
    ###          ESPAM           ###
    ################################
    
    os.chdir(EVAL_TOOL_PATH) # the working directory must be the one containing protobuf_interface.jar
    print (EVAL_TOOL_PATH)
    print (onnx_path)
    cmd = [EVAL_TOOL, '--generate', onnx_path, '-V']
    DEVNULL = os.open(os.devnull, os.O_WRONLY)
    process = subprocess.Popen(cmd, stdout=subprocess.PIPE, universal_newlines=True, stderr=DEVNULL)

    from threading import Timer

    # after this timeout the process will be killed
    timeout=60

    timer = Timer(timeout, process.kill)
    try:
        timer.start()
        stdout, stderr = process.communicate()
    finally:
        timer.cancel()


    print (stdout)

    if "ERROR" in stdout:
      print ("ERROR parsing the ONNX")
      send_back_status(project_id, "Failed", "ERROR parsing the ONNX", engine)
      return

    result = stdout


    app_path=result.split (" ")[-1]

    app_path=app_path[:-2]
    print (app_path)


    # move the outuput to the shared folder
    subprocess.call("mkdir -p %s && cp -rf %s %s && rm -fr %s" % (output_path, app_path, output_path, app_path), shell=True)


  else:
    print ("Engine not valid: {}".format(engine))
    send_back_status(project_id, "Error", "Engine not valid: {}".format(engine), engine)
    return 



  
  return

class CodeGeneration(Resource):

    def post(self):
        print(g.json)
        print(g.args)


        with Connection(conn): # connection to REDIS DB
          q = Queue("codegen",connection=conn)

          params = {"onnx_path"   : g.json.get("onnx_path"),
                    "app_name"    : g.json.get("app_name"),
                    "project_id"  : g.json.get("project_id"),
                    "engine"      : g.args.get("engine"),
                    "callback_id" : g.args.get("callback_id")
                    }

          # enqueue a new job
          job = q.enqueue_call(func=codegen, result_ttl=600000, timeout=600000, kwargs=params)

        return {"message": "Elaboration started", "status":"Running", "job_id": job.id}, 200, None
